//----------------------------------------------------------------
/* カードゲーム赤黒(SPEED)
//----------------------------------------------------------------
// Oh!X 1990/9より移植
// タッチエリア版
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_CHECK='C'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

// タッチエリア
dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------
/*
dim int aka(25),kuro(25)
dim int aka_te(3),kuro_te(3):// 0～3の4枚
int l_card,r_card,r_od=0,b_od=0
int r_sheet=26,b_sheet=26,vic=0,def=0
int man=385,com=32:// カードのy座標
int see=0,pass=0
int g_end=0,begin=1,endf=0
float wt0=2.0,wt:// 待ち時間(X68での実測値ではおおよそ1.7秒だったが、ちょっと早い気がするので)

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

card_init()	:// カードの初期化
init()		:// 画面の初期化
wt=wt0		:// 初期のウエイト
setHumanTouchArea()
//
while (endf=0)	:/* メインプログラム
	nv_init()	:// 変数の初期化
	shuffle()	:// カードのシャッフル
	card_place():// 最初の4枚を表示
	while (g_end=0)
		message(1,0)
		open_card()
		while (begin=1)
			man_play()
			com_play()
		endwhile
	endwhile
endwhile
removeKeys()

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()
end
/*
//----------------------------------------------------------------

func setHumanTouchArea()
// 4枚分左右分
int ps,ky=0
int sx,sy,ey
	touchallcnt=0
	apage(GPAGE3)
	sy=man-8
	ey=man+CARD_WY+8-1
	for ps=0 to 3
		// カードの位置
		int x=143+ps*(CARD_WX+12)
		int y=man+CARD_WY
		// タッチエリアは少し広め
		// 左用
		gColor(&h804000ff)
		sx=x-8
		fill(sx,sy,x+CARD_WX/2-1,ey)
		touchNo(inc(touchallcnt))=setTouchArea(sx,sy,8+CARD_WX/2,8+CARD_WY+8,inc(ky),YES,0,0,0,0)
		// 右用
		gColor(&h400080ff)
		sx=x+CARD_WX/2
		fill(sx,sy,sx+CARD_WX/2+8-1,ey)
		touchNo(inc(touchallcnt))=setTouchArea(sx,sy,CARD_WX/2+8,8+CARD_WY+8,inc(ky),YES,0,0,0,0)
		//
		gColor16X68(8)
	next
	apage(GPAGE2)
	// タッチエリアとキーコードの割付
	// [1:2] [3:4] [5:6] [7:8]
endfunc

func man_play()
/* 人間
int ky,ps,lr
	ky=inkey()
	if ky<>0 then {
		// キーが押されている
		// タッチエリアとキーコードの割付
		// [1:2] [3:4] [5:6] [7:8]		ky
		// [0:1] [2:3] [4:5] [6:7]-1	ky-1
		// [0]   [1]   [2]   [3]=ps
		ps=(ky-1)/2
		lr=ky mod 2:// 左=1,右=0
//		gLocate(0,32):print "ps=";ps,"lr=";lr,"ky=";ky

		pass=0
		switch lr
			case 1:// 左へ
				kuro_nokori(cd_check(ps,0,kuro_te(ps),man),ps)
				break
			case 0:// 右へ
				kuro_nokori(cd_check(ps,1,kuro_te(ps),man),ps)
				break
		endswitch
	}
endfunc

//----------------------------------------------------------------

func com_play()
/* コンピューター
int i,cd,ch
	if (wait(-1)=YES and pass=0) then {
		for i = 0 to 3
			if (aka_nokori(cd_check(see,0,aka_te(see),com),see)) then return
			if (aka_nokori(cd_check(see,1,aka_te(see),com),see)) then return
			see=(see+1) mod 4
		next
		pass=1
		if (vic_check()) then return
		if (man_check()=0) then {
			if (r_od=26 and b_od=26) then judge()
		}
	}
endfunc

//----------------------------------------------------------------

func int aka_nokori(ch;int,ps;int)
/* カードが残っているか
	if (ch=1) then {
		sheet_dsp(0)
		wait(wt,NO)
		if (r_od<26) then card_put(ps,0) else aka_te(ps)=-1
		if (r_sheet=4) then reverse()
		return(1)
	}
	return(0)
endfunc

//----------------------------------------------------------------

func kuro_nokori(ch;int,ps;int)
/* カードが残っているか
int dm
	if (ch=1) then {
		sheet_dsp(1)
		if (b_od<26) then {
			card_put(ps,1)
		} else {
			kuro_te(ps)=-1
			dm=vic_check()
		}
	}
endfunc

//----------------------------------------------------------------

func sheet_dsp(sw;int)
/* 残りの枚数を表示
	switch sw
		case 0:
			r_sheet=r_sheet-1
		case -1:
			if isLocalizeJapan() then {
				gLocate( 4, 3):print using "残り= ##枚";r_sheet
				gLocate( 3, 5):print "コンピューター"
			} else {
				gLocate( 4, 3):print using "Left= ##";r_sheet
				gLocate( 5, 5):print "Computer"
			}
			break
		case 1:
			b_sheet=b_sheet-1
		case -2:
			if isLocalizeJapan() then {
				locate(49*8,27*16-8):print "あなた"
				gLocate(49,28):print using "残り= ##枚";b_sheet
			} else {
				locate(49*8,27*16-8):print "You"
				gLocate(49,28):print using "Left= ##";b_sheet
			}
			break
	endswitch
endfunc

//----------------------------------------------------------------

func int man_check()
/* 出せるカードがあるか
	int i,cd
	for i = 0 to 3
		cd=(kuro_te(i)-1) mod 13 + 1
		if (l_card=cd+1 or l_card=cd-1) then return(1)
		if (r_card=cd+1 or r_card=cd-1) then return(1)
		if (ace_king(l_card,cd) or ace_king(r_card,cd)) then return(1)
	next
	begin=0:return(0)
endfunc

//----------------------------------------------------------------

func int cd_check(n;int,lr;int,c_num;int,pc;int)
/* 出せるカードか
// lr=0:左の山に積む / 1=右の山に積む
int cd,c1,c2
	cd=(c_num-1) mod 13 + 1
	switch lr
		case 0:// 左の山に積む
			if (l_card=cd+1 or l_card=cd-1) then { :// 上下＋1の数字なら出せる
				card_clr(n,pc,0,c_num)
				l_card=cd
				return(1)
			}
			if (ace_king(l_card,cd)) then { :// A<->K
				card_clr(n,pc,0,c_num)
				l_card=cd
				return(1)
			}
			break
		case 1:// 右の山に積む
			if (r_card=cd+1 or r_card=cd-1) then { :// 上下＋1の数字なら出せる
				card_clr(n,pc,1,c_num)
				r_card=cd
				return(1)
			}
			if (ace_king(r_card,cd)) then { :// A<->K
				card_clr(n,pc,1,c_num)
				r_card=cd
				return(1) 
			}
			break
	endswitch
	return(0)
endfunc

//----------------------------------------------------------------

func int ace_king(lr_c;int,cd;int)
/* 場がAかKの場合
	if (lr_c=1 or lr_c=13) then {
		if (lr_c=1 and cd=13) or (lr_c=13 and cd=1) then return(1)
	}
	return(0)
endfunc

//----------------------------------------------------------------

func card_clr(n;int,pc;int,lr;int,c_num;int)
/* カードを出す
int w
	// 元の位置を消す
	w=n*(CARD_WX+12)+143
	gBlend(BlendModeClear)
	gColor(0):fill(w,pc,w+CARD_WX,pc+CARD_WY)
	gBlend(BlendModeNormal)
	// 山に置く(毎回若干ずらす)
	cardPut(lr*121+172+(rnd()*10-5),208+(rnd()*10-5),c_num,NO)
endfunc

//----------------------------------------------------------------

func card_put(n;int,sw;int)
/* 手のカードを追加
int ps
	ps=n*(CARD_WX+12)+143
	switch sw
		case 0:
			cardPut(ps,com, aka(r_od),NO)
			aka_te(n)=aka(r_od)
			r_od=r_od+1
			break
		case 1:
			cardPut(ps,man,kuro(b_od),NO)
			kuro_te(n)=kuro(b_od)
			b_od=b_od+1
			break
	endswitch
endfunc

//----------------------------------------------------------------

func int vic_check()
/* カードがなくなれば勝ち
	if (r_sheet=0) then {
		defeat()
		loop_out()
		return(1)
	} else {
		if (b_sheet=0) then victory():loop_out():return(1)
	}
	return(0)
endfunc

//----------------------------------------------------------------

func judge()
/* カードが残っている場合の判定
int i,j,rs,bs=0,rc=0,bc=0
	for i=0 to 3
		if (aka_te(i)<>-1) then {
			rs=rs+1:rc=rc+((aka_te(i)-1) mod 13+1)
			j=i*(CARD_WX+12)+143:cardPut(j,com,aka_te(i),NO)
		}
		if (kuro_te(i)<>-1) then {
			bs=bs+1:bc=bc+((kuro_te(i)-1) mod 13+1)
		}
	next
	if (rs<bs) then {
		defeat()
	} else { /* 枚数での判定
		if (rs>bs) then {
			victory()
		} else {
			if (rs=bs) then {
				if (rc<bc) then defeat():/* 数字での判定
				if (rc>bc) then victory()
				if (rc=bc) then message(4,0)
			}
		}
	}
	loop_out()
endfunc

//----------------------------------------------------------------

func victory()
/* 勝ち
	vic=vic+1
	wt=wt-(wt0/11.0)*vic:// 1回勝つごとにウエイト時間を減らす
	if wt<0 then wt=0
	/* オリジナルの処理
	/* str level = "t200l8rrrrrrrrrrr":// tempo 200,8分音符,r*11
	/* level=left$(level,len(level)-vic)
	/* 	初回	vic=0	rrrrrrrrrrr		vic+1=1		X68の実測値で1.71s(FM音源なのでクロックには関係なし)
	/* 		1		rrrrrrrrrr		2
	/*		2		rrrrrrrr		3
	/*		3		rrrrr			4
	/*		4		なし
	if (vic=3) then {
		// 3回連続で勝った時
		game_end(vic,def,0):/* 結果表示
		message(5,0)
		question()
	} else message(3,0)
endfunc

//----------------------------------------------------------------

func defeat()
/* 負け
	def=def+1
	if (def=3) then {
		// 3回連続で負けた時
		game_end(vic,def,1)
		message(8,0)
		question()
	} else message(2,0)
endfunc

//----------------------------------------------------------------

func question()
/* 質問
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度やりますか?"
		menues={"はい","いいえ"}
	} else {
		title$="Try again ?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0:// YES
			// 勝敗を初期化して再開
			vic=0:def=0
			wt=wt0:// ウエイトも戻す
			break
		case 1:// NO
			endf=1
			break
	endswitch
	loop_out()
endfunc

//----------------------------------------------------------------

func loop_out()
/* ループを抜ける場合(ゲーム再開)
	pass=1
	begin=0
	g_end=1
	wipe()
endfunc

//----------------------------------------------------------------

func open_card()
/* 赤黒1枚ずつ場に表示
	if (r_od<26) then {
		cardPut(172,208,aka(r_od),NO)
		l_card=(aka(r_od)-1) mod 13+1
		r_od=r_od+1:sheet_dsp(0)
		if (r_sheet=4) then reverse():/* 残り4枚になったら裏返す
	}
	if (b_od<26) then {
		cardPut(293,208,kuro(b_od),NO)
		r_card=(kuro(b_od)-1) mod 13+1
		b_od=b_od+1:sheet_dsp(1)
	}
	wait(wt,NO)
	begin=1:pass=0
endfunc

//----------------------------------------------------------------

func shuffle()
/* シャッフル
int i,j,k,l
	message(6,1)
	for i=0 to 50
		j=rnd()*25:k=rnd()*25
		l=aka(j):aka(j)=aka(k):aka(k)=l
		j=rnd()*25:k=rnd()*25
		l=kuro(j):kuro(j)=kuro(k):kuro(k)=l
	next
	mess_clr()
endfunc

//----------------------------------------------------------------

func int drawBaArea(lr;int,fline;int)
// 場のエリア表示
int ret=NO
int sx,sy
	sy=208-CARD_WY/2
	switch lr
		case 1:// 右
			sx=293-CARD_WX/2
			ret=YES
			break
		case 0:// 左
			sx=172-CARD_WX/2
			ret=YES
			break
	endswitch
	if ret then {
		int ex,ey
		ex=sx+CARD_WX*2
		ey=sy+CARD_WY*2
		if fline then {
			// 一回り大きく描画
			lineWidth(2)
			box(sx-1,sy-1,ex+1,ey+1)
		} else {
			fill(sx,sy,ex,ey)
		}
	}
	return (ret)
endfunc

//----------------------------------------------------------------

func init()
/* 初期設定
int i,j
	vpageX68(13)
	setgPalet16X68(1,&h000000ff)

	// 下地
	apage(GPAGE3):wipe()
	gColor16X68( 8):fill(  0,  0,511,511)
	gColor16X68( 1):fill( 24, 40,127, 72)
	gColor16X68( 1):fill(384,440,487,472)
	gColor16X68(15):box(  26, 42,125, 70)
	gColor16X68(15):box( 386,442,485,470)

	// 場の判定範囲
	gColor(&h00800080)
	drawBaArea(0,NO):// 左
	drawBaArea(1,NO):// 右

	r_sheet=26:sheet_dsp(-1)
	b_sheet=26:sheet_dsp(-2)
	
	// ？
	apage(GPAGE1):wipe()
	gColor16X68( 1):fill(130,227,380,267)
	gColor16X68(15):box( 132,229,378,265)

	// カード
	apage(GPAGE2):wipe()
	for i=0 to val(right$(time$,2)):rnd():next
endfunc

//----------------------------------------------------------------

func nv_init()
/* 変数の初期化
	r_od=0
	b_od=0
	g_end=0
	begin=1
	see=0
	pass=0
	r_sheet=26
	b_sheet=26
endfunc

//----------------------------------------------------------------

func card_init()
/* 赤と黒に分ける
int i,j,sr=1,sb=0
	repeat
		for i=1 to 13
			 aka(j)=sr*13+i
			kuro(j)=sb*13+i
			j=j+1
		next
		sr=sr+1:sb=sb+3
	until (j=26)
endfunc

//----------------------------------------------------------------

func card_place()
/* 最初の(上下)4枚を表示
int i,j=3
	for i=0 to 3
		card_put(i,1)
		card_put(j,0)
		j=j-1
	next
endfunc

//----------------------------------------------------------------

func reverse()
/* カードを裏向ける
int i,j
	for i=0 to 3
		j=i*(CARD_WX+12)+143:cardPut(j,com,0,NO)
	next
endfunc

//----------------------------------------------------------------

func message(n;int,rt;int)
/* メッセージ表示
str m
	switch n
		case 1:m=localizedString("   画面タップでゲーム開始   "	,"  Screen tap to start!!  "):break
		case 2:m=localizedString("  コンピューターの勝ちです  "	,"       Computer Win      "):break
		case 3:m=localizedString("       貴方の勝ちです      "	,"          You Win        "):break
		case 4:m=localizedString("         引き分け         "	,"           Draw          "):break
		case 5:m=localizedString("    貴方は赤黒の天才です    "	,"      You are genious.   "):break
		case 6:m=localizedString("    シャッフルしています    "	,"       Now shuffling     "):break
		case 8:m=localizedString("          残念でした      "	,"   You are unfortunate.  "):break
//		case 7:m=" もう一度やりますか [Y] [N] ":break
	endswitch
	vpageX68(14)
	gLocate(18,15):print m
	if rt then return

	// 一旦タッチが離されるまで待つ
	while getTouchStatus()=TOUCH_NONE
	endwhile

	// タッチされるのを待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	mess_clr()
endfunc

//----------------------------------------------------------------

func game_end(v;int,d;int,pc;int)
/* 結果表示
str p,c,m
dim str vd(1)={"勝ち","負け"}
	vpageX68(14)
	gLocate(20,15)
	if isLocalizeJapan() then {
		p=utf8Mid$("０１２３４５６７８９",v+1,1)
		c=utf8Mid$("０１２３４５６７８９",d+1,1)
		m=p+"勝"+c+"敗で貴方の" + vd(pc) + "です"
	} else {
		vd={"win","lose"}
		m="You "+vd(pc)+" "+chr$('0'+v)+"-on-"+chr$('0'+d)
	}
	print m
	hitKey(NO)
	mess_clr()
endfunc

//----------------------------------------------------------------

func mess_clr()
/* メッセージ消去
	gLocate(18,15):print space$(28)
	vpageX68(13)
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
